<template>
    <div class="container">
      <form method="post">
        <div class="form-group">
          <label for="nameEl">
            Ürituse nimi
            <input type="text" class="form-control" id="nameEl" v-model="eventName"/>
            <span v-if="v$.eventName.$error"> {{ v$.eventName.$errors[0].$message }} </span>
          </label>
        </div>
        <div class="form-group">
            Ürituse aeg
            <VueDatePicker
              locale="et"
              cancelText="Katkesta" selectText="Vali"
              id="timeEl"
              :min-date="new Date()"
              v-model="eventTime"
              prevent-min-max-navigation />
        </div>
        <div class="form-group">
          <label for="placeEl">
            Ürituse toimumise koht
            <input type="text" class="form-control" id="placeEl" v-model="eventPlace" />
          </label>
        </div>
        <div class="form-group">
          <label for="moreEl">
            Lisainfo
            <textarea class="form-control" id="moreEl" v-model="moreInfo" />
          </label>
        </div>
        <a href="/">tagasi</a>
        <button type="button" @click="submitForm" class="btn btn-primary">Lisa</button>
      </form>
    </div>
</template>

<script>
import VueDatePicker from '@vuepic/vue-datepicker';
import '@vuepic/vue-datepicker/dist/main.css';
import useValidate from '@vuelidate/core';
import { required } from '@vuelidate/validators';
import axios from 'axios';

export default {
  name: 'NewEvent',
  components: { VueDatePicker },
  data() {
    return {
      v$: useValidate(),
      eventTime: '',
      eventName: '',
      eventPlace: '',
      moreInfo: '',
    };
  },
  methods: {
    submitForm() {
      this.v$.$validate();
      if (!this.v$.$error) {
        axios.post(
          'http://localhost:5000/yritus',
          {
            nimi: this.eventName,
            koht: this.eventPlace,
            aeg: this.eventTime,
            lisainfo: this.moreInfo,
          },
          { headers: { 'Content-type': 'application/json' } },
        ).then(() => {
          window.location.href = '/';
        }).catch((error) => {
          alert(error.response.data.message);
        });
      } else {
        return false;
      }
      return true;
    },
  },
  validations() {
    return {
      eventName: { required },
      eventPlace: { required },
      eventTime: { required },
    };
  },
};
</script>
